<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\ModeloDocumentoCdaService;
use SM\Traits\TResponse;

class ModeloDocumentoCdaController extends SMCrud
{

    use TResponse;

    protected $ModeloDocumentoCdaService;

    public function __construct($crudService, $environment, ModeloDocumentoCdaService $ModeloDocumentoCdaService)
    {
        parent::__construct($crudService, $environment);
        $this->ModeloDocumentoCdaService=$ModeloDocumentoCdaService;
    }

    public function getInformacoesModeloDocumentoCda()
    {
        try {
            $data = $this->ModeloDocumentoCdaService->getInformacoesModeloDocumentoCda();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTabAnexoCda(Request $request)
    {
        try {
            $data = $this->ModeloDocumentoCdaService->getTabAnexoCda($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    } 

    public function getModeloDocumentoPadraoCda(Request $request)
    {
        try {
            $data = $this->ModeloDocumentoCdaService->getModeloDocumentoPadraoCda($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inserirModeloDocumentoCda(Request $request)
    {
        try {
            $this->ModeloDocumentoCdaService->inserirModeloDocumentoCda($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function inserirModeloDocumentoIdiomaCda(Request $request)
    {
        try {
            $this->ModeloDocumentoCdaService->inserirModeloDocumentoIdiomaCda($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveTabModeloDocumentoCda(Request $request)
    {
        try {
            $this->ModeloDocumentoCdaService->saveTabModeloDocumentoCda($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletarModeloDocumentoCda(Request $request)
    {
        try {
            $this->ModeloDocumentoCdaService->deletarModeloDocumentoCda($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletarAnexoCda(DTO\Request $request)
    {
        try {
            $this->ModeloDocumentoCdaService->deletarAnexoCda($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function downloadAnexoModeloDocumentoCda(Request $request)
    {
        $params = $request->getParameters();
        $nrmodelodoccdaidi = $params["nrmodelodoccdaidi"];
        $this->ModeloDocumentoCdaService->downloadAnexoModeloDocumentoCda($nrmodelodoccdaidi);
    }

    public function deletarAnexoModeloDocumentoCda(Request $request)
    {
        try {
            $this->ModeloDocumentoCdaService->limparAnexoModeloDocumentoCda($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
