import { Utilities } from '@/util/Utilities';
import {
    Form, LoadingService, Select, TextInput,
} from '@zeedhi/common';
import { Http, Loader, Metadata } from '@zeedhi/core';
import { TekGrid } from '@zeedhi/teknisa-components-common';

export class Sm00004006TabDocumentoContratoController {
    public gridDocumentoContrato = Loader.getInstance('Sm00004006DocumentoContratoController');

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;

        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public editarDocumentoContrato() {
        const gridDocumentoContrato = Metadata.getInstance<TekGrid>('tek-grid-documento_contrato_grid');
        const params = {
            IDPADRAO: Metadata.getInstance<Select>('formDadosDocumentoContrato-IDPADRAO').value,
            VRTAMANHOLOGO: Metadata.getInstance<TextInput>('formDadosDocumentoContrato-VRTAMANHOLOGO').value,
            NRSEQCONTDOC: this.gridDocumentoContrato.currentRow.NRSEQCONTDOC,
        };
        LoadingService.show();
        Http.post('/editarDocumentoContrato', params)
            .then(() => {
                Utilities.showSuccessMessage();
                gridDocumentoContrato.datasource.get();
                this.gridDocumentoContrato.voltarTekGridDocumentoContrato();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }
}
